var fs = require('fs');
var path = require('path');
var crypto = require('crypto');

var CACHE_PATH = path.resolve(__dirname, './.cache');

function getMD5(secret) {
  var md5 = crypto.createHash('md5');
  return md5.update(secret).digest('hex');
}

function getCache(filename) {
  var realPath = path.resolve(CACHE_PATH, filename);
  if (!fs.existsSync(realPath)) {
    return '';
  }
  return fs.readFileSync(realPath).toString();
}

function setCache(filename, content) {
  var realPath = path.resolve(CACHE_PATH, filename);
  fs.writeFileSync(realPath, content);
}

module.exports = {
  getMD5: getMD5,
  getCache: getCache,
  setCache: setCache
}
