/**
 * fis3-parser-babel-imweb
 * @author jero
 * @date 2016-08-11
 */
var babel;
try {
  babel = require('@babel/core');
} catch(e) {
  babel = require('babel-core');
}
var cache = require('./cache');

module.exports = function (content, file, conf) {

  // 添加 useBabel 配置项，如果 useBabel 为 false 则不进行编译
  if (file.useBabel === false) {
    return content;
  }

  var md5 = cache.getMD5(content);
  var cacheContent = cache.getCache(md5);
  if (cacheContent) {
    return cacheContent;
  }

  // 添加 jsx 的 html 语言能力处理
  if (fis.compile.partial && file.ext === '.jsx') {
    content = fis.compile.partial(content, file, {
      ext: '.html',
      isHtmlLike: true
    });
  }

  var sourceMapRelative = conf.sourceMapRelative;

  if (sourceMapRelative) {
    delete conf.sourceMapRelative;
  }

  // 出于安全考虑，不使用原始路径
  conf.filename = file.subpath.substring(1);
  var result = babel.transform(content, conf);

  // 添加resourcemap输出
  if (result.map) {
    var mapping = fis.file.wrap(file.dirname + '/' + file.filename + file.rExt + '.map');
    mapping.setContent(JSON.stringify(result.map, null, 4));
    var url = sourceMapRelative ? ('./' + file.basename + '.map').replace('jsx', 'js') :
      mapping.getUrl(fis.compile.settings.hash, fis.compile.settings.domain);
    result.code = result.code.replace(/\n?\s*\/\/#\ssourceMappingURL=.*?(?:\n|$)/g, '');
    result.code += '\n//# sourceMappingURL=' + url + '\n';
    file.extras = file.extras || {};
    file.extras.derived = file.extras.derived || [];
    file.extras.derived.push(mapping);
  }

  cache.setCache(md5, result.code);
  return result.code;
};
